%%% Thomas A. Adams II
%%% thomas.a.adams@ntnu.no
%%% June 2020 Release
%%% This code is given without warranty or license, provided AS-IS
%%% Please site the corresponding academic journal article when citing and using this code:
%%%
%%% Christian DA, Adams TA II, et al. cDC1 coordinate innate and adaptive responses in the omentum required 
%%% for T cell priming and memory. Science Immunology 7, eabq7432 (2022). 
%%% https://doi.org/10.1126/sciimmunol.abq7432
%%%
%%% That paper is the documentation. This code is not actively maintained and may have incomplete parts.
%%%
%%% This contains the probability that a transition will occur given the age of the cell in hours. See paper for explanation.

function DidItTransition = APTransition(age)

ages = [
0.2
0.3
0.4
0.5
0.6
0.7
0.8
0.9
1
1.1
];

probs = [0
0.6
3.9
15.1
38.2
61.7
63.9
42.5
18.1
4.9
0.9
100
] / 100;

% if too soon
if (age < ages(1))
   DidItTransition = 0;
   return;
end

% Find the bin we care about
binindex = find(ages>=age, 1, 'first');

% if not found
if isempty(binindex)
  % ite means we are at the end of the array. in this example, we assume
  % it will definitely transition
  DidItTransition = 1;
  return;
end

% else we have a bin index. compute the probability of transition
DidItTransition = rand(1) < probs(binindex);
return;



 