%%% Thomas A. Adams II
%%% thomas.a.adams@ntnu.no
%%% June 2020 Release
%%% This code is given without warranty or license, provided AS-IS
%%% Please site the corresponding academic journal article when citing and using this code:
%%%
%%% Christian DA, Adams TA II, et al. cDC1 coordinate innate and adaptive responses in the omentum required 
%%% for T cell priming and memory. Science Immunology 7, eabq7432 (2022). 
%%% https://doi.org/10.1126/sciimmunol.abq7432
%%%
%%% That paper is the documentation. This code is not actively maintained and may have incomplete parts.
%%%
%%% This contains the probability that a transition will occur given the age of the cell in hours. See paper for explanation.

function DidItTransition = SplitTransition(age)

ages = [
3.3
3.4
3.5
3.6
3.7
3.8
3.9
4
4.1
4.2
4.3
4.4
4.5
4.6
4.7
4.8
4.9
5
5.1
5.2
5.3
5.4
5.5
5.6
5.7
5.8
5.9
6
6.1
6.2
6.3
6.4
6.5
6.6
6.7
6.8
6.9
7
7.1
7.2
7.3


];

probs = [ 0.00000 
 0.00001 
 0.00001 
 0.00003 
 0.00008 
 0.00017 
 0.00037 
 0.00075 
 0.00147 
 0.00278 
 0.00505 
 0.00880 
 0.01474 
 0.02372 
 0.03669 
 0.05451 
 0.07783 
 0.10675 
 0.14068 
 0.17812 
 0.21669 
 0.25327 
 0.28443 
 0.30689 
 0.31813 
 0.31686 
 0.30322 
 0.27879 
 0.24628 
 0.20903 
 0.17046 
 0.13355 
 0.10053 
 0.07271 
 0.05053 
 0.03373 
 0.02164 
 0.01334 
 0.00790 
 0.00449 
 0.00246 


] ;

% if too soon
if (age < ages(1))
   DidItTransition = 0;
   return;
end

% Find the bin we care about
binindex = find(ages>=age, 1, 'first');

% if not found
if isempty(binindex)
  % ite means we are at the end of the array. in this example, we assume
  % it will definitely did not transition (terminated)
  DidItTransition = 0;
  return;
end

% else we have a bin index. compute the probability of transition
DidItTransition = rand(1) < probs(binindex);
return;



 